#include <Xm/FileSB.h>
#include <Xm/MessageB.h>
#include <Xm/RowColumn.h>
#include <Xm/LabelG.h>
#include <Xm/TextF.h>
#include <Xm/Text.h>
#include <Xm/List.h>
#include <X11/cursorfont.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include "global.h"

void f_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget        toplevel;
  int           item, i;
  int           cols, rows;
  static Widget fsb_ld, ft_ld, fsb_sd, ft_sd, new_dialog;
  XmStringTable str_list;
  Widget        rc;
  Arg           args[5];

  void ld_cb(Widget, XtPointer, XtPointer);
  void sd_cb(Widget, XtPointer, XtPointer);
  void cancel_cb(Widget, XtPointer, XtPointer);
  void newok_cb(Widget, XtPointer, XtPointer);
  
  toplevel=XtParent(widget);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);

  item=(int) client_data;
  switch(item) {
  case 0:      // new;
    if (!new_dialog) {
      i=0;
      XtSetArg(args[i], XmNautoUnmanage, False); i++;
      XtSetArg(args[i], XmNdialogTitle,
	       XmStringCreateLocalized("New data set")); i++;
      XtSetArg(args[i], XmNmessageString,
	       XmStringCreateLocalized("Number of rows and columns:")); i++;
      new_dialog=XmCreateMessageDialog(toplevel, "newdialog", args, i);
      rc=XtVaCreateWidget("rc", xmRowColumnWidgetClass, new_dialog,
			  XmNorientation, XmHORIZONTAL,
			  XmNpacking, XmPACK_COLUMN,
			  XmNnumColumns, 2,
			  NULL);
      XtVaCreateManagedWidget("label", xmLabelGadgetClass, rc,
			      XmNlabelString, XmStringCreateLocalized("rows: "),
			      NULL);
      XtVaCreateManagedWidget("rows", xmTextFieldWidgetClass, rc,
			      XmNcolumns, 10,
			      XmNvalue, "1",
			      NULL);
      XtVaCreateManagedWidget("label", xmLabelGadgetClass, rc,
			      XmNlabelString, XmStringCreateLocalized("columns: "),
			      NULL);
      XtVaCreateManagedWidget("columns", xmTextFieldWidgetClass, rc,
			      XmNcolumns, 10,
			      XmNvalue, "1",
			      NULL);
      XtManageChild(rc);
      XtAddCallback(new_dialog, XmNokCallback, newok_cb, NULL);
      XtAddCallback(new_dialog, XmNcancelCallback, cancel_cb, NULL);
    }
    XtManageChild(new_dialog);
    XtPopup(XtParent(new_dialog), XtGrabNone);
    break;
  case 1:      // load data;
    if (!fsb_ld) {
      fsb_ld=XmCreateFileSelectionDialog(toplevel, "filesb", NULL, 0);
      XtVaSetValues(XtParent(fsb_ld),
		    XmNtitle, "Load Data",
		    NULL);
      str_list=(XmStringTable) XtMalloc(2*sizeof(XmString));
      str_list[0]=XmStringCreateLocalized("ASCII");
      str_list[1]=XmStringCreateLocalized("STAT");
      ft_ld=XmCreateScrolledList(fsb_ld, "filetype", NULL, 0);
      XtVaSetValues(ft_ld,
		    XmNselectionPolicy, XmSINGLE_SELECT,
		    XmNvisibleItemCount, 2,
		    XmNitemCount, 2,
		    XmNitems, str_list,
		    NULL);
      XmListSelectPos(ft_ld, 1, True);

      XtAddCallback(fsb_ld,XmNokCallback, ld_cb, ft_ld);
      XtAddCallback(fsb_ld,XmNcancelCallback, cancel_cb, NULL);
      XtFree((char *)str_list);
    }
    XtManageChild(ft_ld);
    XtManageChild(fsb_ld);
    break;
  case 2:      // save data;
    if (!fsb_sd) {
      fsb_sd=XmCreateFileSelectionDialog(toplevel, "filesb", NULL, 0);
      str_list=(XmStringTable) XtMalloc(2*sizeof(XmString));
      str_list[0]=XmStringCreateLocalized("ASCII");
      str_list[1]=XmStringCreateLocalized("STAT");
      ft_sd=XmCreateScrolledList(fsb_sd, "filetype", NULL, 0);
      XtVaSetValues(ft_sd,
		    XmNselectionPolicy, XmSINGLE_SELECT,
		    XmNvisibleItemCount, 2,
		    XmNitemCount, 2,
		    XmNitems, str_list,
		    NULL);
      XmListSelectPos(ft_sd, 1, True);
      XtAddCallback(fsb_sd,XmNokCallback, sd_cb, ft_sd);
      XtAddCallback(fsb_sd,XmNcancelCallback, cancel_cb, NULL);
      XtVaSetValues(XtParent(fsb_sd),
		    XmNtitle, "Save Data",
		    NULL);
      XtFree((char *)str_list);
    }
    XtManageChild(ft_sd);
    XtManageChild(fsb_sd);
    break;
  case 3:      // close;
    XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
    XtVaGetValues(StatData, XmNrows, &rows, NULL);
    XbaeMatrixDeleteColumns(StatData, 0, cols-1);
    XbaeMatrixDeleteRows(StatData, 0, rows-1);
    XbaeMatrixSetCell(StatData, 0, 0, EMPTY);
    XtUnmanageChild(StatData);
    sort.nsort  = 0;
    sort.sort=(int *)realloc(sort.sort, sizeof(int));
    sort.ndep   = 0;
    sort.dep=(int *)realloc(sort.dep, sizeof(int));
    sort.ngroup = 1;
    sort.group=(int *)realloc(sort.group, sizeof(int));
    last_var_num=0; // last variable number for automatic var name construction;
    XtSetSensitive(mymenu.file.s_data, False);
    XtSetSensitive(mymenu.file.c_data, False);
    XtSetSensitive(mymenu.file.n_data, True);
    XtSetSensitive(mymenu.file.l_data, True);
    XtSetSensitive(mymenu.utils.u_menu, False);
    XtSetSensitive(mymenu.stats.s_menu, False);
    XtSetSensitive(mymenu.edit.e_menu, False);
    XtSetSensitive(mymenu.region.r_menu, False);
    XtSetSensitive(tabs.open, True);
    XtSetSensitive(tabs.add_col_l, False);
    XtSetSensitive(tabs.add_col_r, False);
    XtSetSensitive(tabs.add_row_top, False);
    XtSetSensitive(tabs.add_row_bot, False);
    XtSetSensitive(tabs.del_row, False);
    XtSetSensitive(tabs.del_col, False);
    break;
  case 4:      // quit;
    delete[]reg.data;
    exit(0);
    break;
  }
}

/* ..................................*/
/* .....   C a l l b a c k s   ..... */
/* ................................. */

void cancel_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  XtUnmanageChild(widget);
}

void ld_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  std::ifstream indat;
  char     *filename, cd[5], buf[100];
  int      *pos_list, pos_cnt;
  int      i, j, rows, cols;
  float    ver;
  char     *linie, *lstart, *clinie, *ilinie, *istart;
  Cursor   uhr, pfeil;
  short    *colwidth;
  String   *lcol, *lrow;
  String   *rowArrays, **cells;

  /* get filename */
  XmFileSelectionBoxCallbackStruct *cbs=
    (XmFileSelectionBoxCallbackStruct *) call_data;
  if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &filename)) {
    std::cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    std::cout << "No file selected! \n";
    XtFree(filename);
    return;
  }

  /* set cursor */
  uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
  XFlush(XtDisplay(widget));

  /* get filetype 1: ASCII, 2: STAT, returned in pos_list[0] */
  XmListGetSelectedPos((Widget)client_data,&pos_list,&pos_cnt);

  switch(pos_list[0]) {
  case 1: /* ASCII file */
    /* Initialisierung */
    cd[0]=' '; cd[1]='\t'; cd[2]=(char)0x0D; cd[3]='\n'; cd[4]='\0';
    linie=(char *) malloc(10001);
    lstart=linie;
    ilinie=(char *) malloc(10001);
    istart=ilinie;
    // validate opening of file;
    indat.open(filename);
    if (!indat) {
      std::cout << "Can't open file: " << filename << "\n";
    }
    else {
      // Anzahl der Spalten feststellen;
      indat.getline(linie,10000);
      rows=1;
      strcpy(ilinie,linie);
      clinie=strtok(ilinie,cd);
      cols=1;
      while (clinie) {
	clinie=strtok(NULL, cd);
	cols++;
      } /* endwhile */
      cols--;
      // Anzahl der Reihen feststellen;
      while (!indat.eof()) {
	indat.getline(linie, 10000);
	rows++;
      }
      if (rows>0 && cols>0) {
	/* allocation of data array */
	cells = (String **)XtMalloc(rows * sizeof(String *));
	rowArrays = (String *)XtMalloc(rows * cols * sizeof(String));
	colwidth=new short [cols];
	lcol=(String *)XtMalloc(cols * sizeof(String));
	lrow=(String *)XtMalloc(rows * sizeof(String));
	for (i=0; i<cols; i++) {
	  colwidth[i]=COLWIDTH;
	  sprintf(buf, "Var%d", i+1);
	  lcol[i]=(String) XtNewString(buf);
	}
	last_var_num=cols;
	for (i=0; i<rows; i++) {
	  sprintf(buf, "%d", i+1);
	  lrow[i]=(String) XtNewString(buf);
	}
	/* Daten einlesen */
	indat.close();
	indat.clear();	
	indat.open(filename);
	for (i=0; i<rows; i++) {
	  cells[i] = &rowArrays[i * cols];
	  indat.getline(linie,10000);
	  strcpy(ilinie,linie);
	  for (j=0; j<cols; j++) {
	    if (j==0) clinie=strtok(ilinie, cd);
	    else      clinie=strtok(NULL, cd);
	    rowArrays[i * cols + j] = (String) XtNewString(clinie);
	  } // endfor;
	} // endfor;
	XbaeMatrixAddColumns(StatData, 1, NULL, NULL, colwidth, NULL, NULL, NULL, NULL, cols-1);
	XbaeMatrixAddRows(StatData, 1, NULL, NULL,  NULL, rows-1);
	XtVaSetValues(StatData,
		      XmNcolumnLabels, lcol,
		      XmNrowLabels, lrow,
		      XmNcells, cells,
		      NULL);
	XtManageChild(StatData);
	//sort.reset_dep(); /* don't select all vars as dependent variables */
	sort.ngroup=1;
	sort.group[0]=rows;
	XtSetSensitive(mymenu.file.s_data, True);
	XtSetSensitive(mymenu.file.c_data, True);
	XtSetSensitive(mymenu.file.n_data, False);
	XtSetSensitive(mymenu.file.l_data, False);
	XtSetSensitive(mymenu.stats.s_menu, True);
	XtSetSensitive(mymenu.edit.e_menu, True);
	XtSetSensitive(mymenu.region.r_menu, True);
	XtSetSensitive(mymenu.utils.u_menu, True);
	XtSetSensitive(tabs.open, False);
	XtSetSensitive(tabs.add_col_l, True);
	XtSetSensitive(tabs.add_col_r, True);
	XtSetSensitive(tabs.add_row_top, True);
	XtSetSensitive(tabs.add_row_bot, True);
	XtSetSensitive(tabs.del_row, True);
	XtSetSensitive(tabs.del_col, True);
	XtVaSetValues(mess_label, XmNlabelString, XmStringCreateLocalized(filename), NULL);
	delete [] colwidth;
	XtFree((char *) rowArrays);
	XtFree((char *) cells);
	for (i=0; i<rows; i++) XtFree(lrow[i]);
	for (i=0; i<cols; i++) XtFree(lcol[i]);
	XtFree((char *) lrow);
	XtFree((char *) lcol);
      } //endif;
    }
    indat.close();
    ilinie=istart; linie=lstart;
    free(ilinie); free(linie);
    break;

  case 2: /* STAT file */
    /* Initialisierung */
    linie=(char *) malloc(10001);
    lstart=linie;
    ilinie=(char *) malloc(10001);
    istart=ilinie;
    // validate opening of file;
    indat.open(filename);
    if (!indat) {
      std::cout << "Can't open file: " << filename << "\n";
    }
    else {
      // Anzahl der Spalten und Reihen feststellen;
      indat.getline(linie,10000);
      ver=atof(linie);
      indat.getline(linie,10000);
      strcpy(ilinie,linie);
      clinie=strtok(ilinie,"@");
      cols=atoi(clinie);
      clinie=strtok(NULL, "@");
      rows=atoi(clinie);
      if (rows>0 && cols>0) {
	/* allocation of data array */
	cells = (String **)XtMalloc(rows * sizeof(String *));
	rowArrays = (String *)XtMalloc(rows * cols * sizeof(String));
	colwidth=new short [cols];
	lcol=(String *)XtMalloc(cols * sizeof(String));
	lrow=(String *)XtMalloc(rows * sizeof(String));
	/* read column labels */
	indat.getline(linie,10000);
	strcpy(ilinie,linie);
	clinie=strtok(ilinie,"@");
	lcol[0]=(String) XtNewString(clinie);
	for (i=1; i<cols; i++) {
	  clinie=strtok(NULL,"@");
	  lcol[i]=(String) XtNewString(clinie);
	}
	last_var_num=cols; // last variable number for automatic var name construction;
	/* read colwidths     */
	indat.getline(linie,10000);
	strcpy(ilinie,linie);
	clinie=strtok(ilinie,"@");
	colwidth[0]=atoi(clinie);
	for (i=1; i<cols; i++) {
	  clinie=strtok(NULL,"@");
	  colwidth[i]=atoi(clinie);
	}
	/* Daten einlesen */
	for (i=0; i<rows; i++) {
	  cells[i] = &rowArrays[i * cols];
	  indat.getline(linie,10000);
	  strcpy(ilinie,linie);
	  clinie=strtok(ilinie, "@");
	  lrow[i]=(String) XtNewString(clinie);
	  for (j=0; j<cols; j++) {
	    clinie=strtok(NULL, "@");
	    rowArrays[i * cols + j] = (String) XtNewString(clinie);
	  } // endfor;
	} // endfor;
	XbaeMatrixAddColumns(StatData, 1, NULL, NULL, colwidth, NULL, NULL, NULL, NULL, cols-1);
	XbaeMatrixAddRows(StatData, 1, NULL, NULL,  NULL, rows-1);
	XtVaSetValues(StatData,
		      XmNcolumnLabels, lcol,
		      XmNrowLabels, lrow,
		      XmNcells, cells,
		      NULL);
	XtManageChild(StatData);
	//sort.reset_dep(); /* don't select all vars as dependent variables */
	sort.ngroup=1;
	sort.group[0]=rows;
	XtSetSensitive(mymenu.file.s_data, True);
	XtSetSensitive(mymenu.file.c_data, True);
	XtSetSensitive(mymenu.file.n_data, False);
	XtSetSensitive(mymenu.file.l_data, False);
	XtSetSensitive(mymenu.stats.s_menu, True);
	XtSetSensitive(mymenu.utils.u_menu, True);
	XtSetSensitive(mymenu.edit.e_menu, True);
	XtSetSensitive(mymenu.region.r_menu, True);
	XtSetSensitive(tabs.open, False);
	XtSetSensitive(tabs.add_col_l, True);
	XtSetSensitive(tabs.add_col_r, True);
	XtSetSensitive(tabs.add_row_top, True);
	XtSetSensitive(tabs.add_row_bot, True);
	XtSetSensitive(tabs.del_row, True);
	XtSetSensitive(tabs.del_col, True);
	XtVaSetValues(mess_label, XmNlabelString, XmStringCreateLocalized(filename), NULL);
	delete [] colwidth;
	XtFree((char *) rowArrays);
	XtFree((char *) cells);
	for (i=0; i<rows; i++) XtFree(lrow[i]);
	for (i=0; i<cols; i++) XtFree(lcol[i]);
	XtFree((char *) lrow);
	XtFree((char *) lcol);
      } //endif;
    }
    indat.close();
    ilinie=istart; linie=lstart;
    free(ilinie); free(linie);
    break;
  }

  XtFree(filename);
  XtFree((char *)pos_list);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  XtUnmanageChild(widget);
  return;
}

void sd_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget       fexist;
  Arg          args[5];
  std::fstream outdat;
  extern int   errno;
  Cursor       uhr, pfeil;
  char         *filename, *pcells;
  XmString     fname;
  int          *pos_list, pos_cnt;
  int          i, j, rows, cols;
  short        *colwidth;
  String       *lcol, *lrow;
  String       **cells;

  void kill_file(Widget widget, XtPointer client_data, XtPointer call_data);

  /* get filename */
  XtVaGetValues(widget, XmNdirSpec, &fname, NULL);
  if (!XmStringGetLtoR(fname, XmFONTLIST_DEFAULT_TAG, &filename)) {
    std::cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    std::cout << "No file selected! \n";
    XtFree(filename);
    return;
  }
  /* test whether file already exists */
  outdat.open(filename, std::ios::in);
  if (outdat) {
    outdat.close();
    i=0;
    XtSetArg(args[i], XmNmessageString, XmStringCreateLtoR("File already exists.\n     Overwrite?",XmFONTLIST_DEFAULT_TAG)); i++;
    XtSetArg(args[i], XmNokLabelString, XmStringCreateLocalized(" Yes ")); i++;
    XtSetArg(args[i], XmNcancelLabelString, XmStringCreateLocalized(" No ")); i++;
    XtSetArg(args[i], XmNtitle, "Save Data"); i++;
    XtSetArg(args[i], XmNuserData, client_data); i++;
    fexist=XmCreateQuestionDialog(XtParent(widget), "fexist", args, i);
    XtAddCallback(fexist, XmNokCallback, kill_file, widget);
    XtUnmanageChild(XmMessageBoxGetChild(fexist, XmDIALOG_HELP_BUTTON));
    XtManageChild(fexist);
    XtPopup(XtParent(fexist), XtGrabNone);
  }
  else {
    outdat.clear();
    /* file does not exist - now write data */
    /* set cursor */
    uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
    pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
    XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
    XFlush(XtDisplay(widget));

    /* get filetype 1: ASCII, 2: STAT, returned in pos_list[0] */
    XmListGetSelectedPos((Widget)client_data,&pos_list,&pos_cnt);

    switch(pos_list[0]) {
    case 1: /* ASCII file */
      // validate opening of file;
      outdat.open(filename, std::ios::out);
      if (!outdat) {
	std::cout << "Can't open file: " << filename << "\n";
      }
      else {
	// Anzahl der Spalten und Reihen feststellen;
	XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
	XtVaGetValues(StatData, XmNrows, &rows, NULL);
	XtVaGetValues(StatData, XmNcells, &cells, NULL);
	/* Daten auf ASCII file schreiben */
	for (i=0; i<rows; i++) {
	  for (j=0; j<cols; j++) {
	    if (strtok(cells[i][j]," \t\n\0")==NULL) outdat << "-";
	    else                        outdat << cells[i][j];
	    if (j < (cols-1)) outdat  << "\t";
	    else {
	      if (i < (rows-1)) outdat << "\n";
	    }
	  }
	}
      }
      outdat.close();
      break;

    case 2: /* STAT file */
      // validate opening of file;
      outdat.open(filename, std::ios::out);
      if (!outdat) {
	std::cout << "Can't open file: " << filename << "\n";
      }
      else {
	// Anzahl der Spalten und Reihen feststellen;
	XtVaGetValues(StatData, XmNcolumns, &cols, NULL);
	XtVaGetValues(StatData, XmNrows, &rows, NULL);
	XtVaGetValues(StatData, XmNcells, &cells, NULL);
	XtVaGetValues(StatData, XmNcolumnLabels, &lcol, NULL);
	XtVaGetValues(StatData, XmNrowLabels, &lrow, NULL);
	XtVaGetValues(StatData, XmNcolumnWidths, &colwidth, NULL);
	/* Daten auf ASCII file schreiben */
	/* write file type version */
	outdat << VERSION << " xmstat \n";
	outdat << cols << "@" << rows << "\n";
	/* write column labels */
	for (j=0; j<cols; j++) {
	  if (j<cols-1) outdat << lcol[j] << "@";
	  else          outdat << lcol[j] << "\n";
	}
	/* write column widths */
	for (j=0; j<cols; j++) {
	  if (j<cols-1) outdat << colwidth[j] << "@";
	  else          outdat << colwidth[j] << "\n";
	}
	/* write data and row labels */
	for (i=0; i<rows; i++) {
	  outdat << lrow[i] << "@";
	  for (j=0; j<cols; j++) {
	    if (strtok(cells[i][j]," \t\n\0")==NULL) outdat << " ";
	    else                        outdat << cells[i][j];
	    if (j < (cols-1)) outdat << "@";
	    else {
	      if (i < (rows-1)) outdat << "\n";
	    }
	  }
	}
      }
      outdat.close();
      break;
    }
    XtVaSetValues(mess_label, XmNlabelString, XmStringCreateLocalized(filename), NULL);
    XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
    XFreeCursor(XtDisplay(widget), pfeil);
    XFreeCursor(XtDisplay(widget), uhr);
    XtFree((char *)pos_list);
    XtUnmanageChild(widget);
  }
  XtFree(filename);
  return;
}



void newok_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  char   *rs, *cs, buf[100];
  int    rows, cols, i;
  short  *colwidth;
  String *lcol, *lrow;

  rs=XmTextFieldGetString(XtNameToWidget(XtNameToWidget(widget, "rc"),"rows"));
  cs=XmTextFieldGetString(XtNameToWidget(XtNameToWidget(widget, "rc"),"columns"));
  rows=atoi(rs); cols=atoi(cs);

  if (rows>0 && cols>0) {
    lrow=(String *)XtMalloc(rows * sizeof(String));
    lcol=(String *)XtMalloc(cols * sizeof(String));
    colwidth=new short [cols];
    for (i=0; i<cols; i++) {
      colwidth[i]=COLWIDTH;
      sprintf(buf, "Var%d", i+1);
      lcol[i]=(String) XtNewString(buf);
    }
    last_var_num=cols;
    for (i=0; i<rows; i++) {
      sprintf(buf, "%d", i+1);
      lrow[i]=(String) XtNewString(buf);
    }
    XbaeMatrixAddColumns(StatData, 1, NULL, NULL, colwidth, NULL, NULL, NULL, NULL, cols-1);
    XbaeMatrixAddRows(StatData, 1, NULL, NULL,  NULL, rows-1);
    XtVaSetValues(StatData,
		  XmNcolumnLabels, lcol,
		  XmNrowLabels, lrow,
		  NULL);
    XtUnmanageChild(widget);
    XtManageChild(StatData);
    // sort.reset_dep();  /* don't select all vars as dependent variables */
    sort.group[0]=rows;
    XtSetSensitive(mymenu.file.s_data, True);
    XtSetSensitive(mymenu.file.c_data, True);
    XtSetSensitive(mymenu.file.n_data, False);
    XtSetSensitive(mymenu.file.l_data, False);
    XtSetSensitive(mymenu.stats.s_menu, True);
    XtSetSensitive(mymenu.edit.e_menu, True);
    XtSetSensitive(mymenu.region.r_menu, True);
    XtSetSensitive(mymenu.utils.u_menu, True);
    XtSetSensitive(tabs.open, False);
    XtSetSensitive(tabs.add_col_l, True);
    XtSetSensitive(tabs.add_col_r, True);
    XtSetSensitive(tabs.add_row_top, True);
    XtSetSensitive(tabs.add_row_bot, True);
    XtSetSensitive(tabs.del_row, True);
    XtSetSensitive(tabs.del_col, True);
    XtVaSetValues(mess_label, XmNlabelString, XmStringCreateLocalized(" "), NULL);
    delete [] colwidth;
    for (i=0; i<rows; i++) XtFree(lrow[i]);
    for (i=0; i<cols; i++) XtFree(lcol[i]);
    XtFree((char *) lcol);
    XtFree((char *) lrow);
  }
  else {
    XtVaSetValues(mess_label,
		  XmNlabelString, XmStringCreateLocalized(
		  "number of rows and columns must be larger than 0 ! "),
		  NULL);
  }
  
  XtFree(rs); XtFree(cs);
}

void kill_file(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget   fsb_sd, ft_sd;
  XmString fname;
  char     *filename, *cmd;

  cmd=new char[256];
  XtVaGetValues(widget, XmNuserData, &ft_sd, NULL);
  fsb_sd=(Widget) client_data;
  XtVaGetValues(fsb_sd, XmNdirSpec, &fname, NULL);
  if (XmStringGetLtoR(fname, XmFONTLIST_DEFAULT_TAG, &filename)) {
    sprintf(cmd, "rm %s", filename);
    std::cout << cmd << "\n";
    system(cmd);
    XtFree(filename);
    sd_cb(fsb_sd, (XtPointer)ft_sd, NULL);
  }
  delete[]cmd;
}
